"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const lowcode_code_generator_1 = tslib_1.__importDefault(require("@alilc/lowcode-code-generator"));
const MenuConfig_1 = tslib_1.__importDefault(require("./plugins/MenuConfig"));
function createLcpCodegenProjectBuilder() {
    // @ts-ignore
    return lowcode_code_generator_1.default.createProjectBuilder({
        template: lowcode_code_generator_1.default.solutionParts.icejs.template,
        plugins: {
            components: [
                lowcode_code_generator_1.default.plugins.react.reactCommonDeps(),
                lowcode_code_generator_1.default.plugins.common.esmodule({ fileType: 'jsx' }),
                lowcode_code_generator_1.default.plugins.react.containerClass(),
                lowcode_code_generator_1.default.plugins.react.containerInjectContext(),
                lowcode_code_generator_1.default.plugins.react.containerInjectUtils(),
                lowcode_code_generator_1.default.plugins.react.containerInjectDataSourceEngine(),
                lowcode_code_generator_1.default.plugins.react.containerInjectI18n(),
                lowcode_code_generator_1.default.plugins.react.containerInitState(),
                lowcode_code_generator_1.default.plugins.react.containerLifeCycle(),
                lowcode_code_generator_1.default.plugins.react.containerMethod(),
                lowcode_code_generator_1.default.plugins.react.jsx({
                    nodeTypeMapping: {
                        Div: 'div',
                        Component: 'div',
                        Page: 'div',
                        Block: 'div',
                    },
                }),
                lowcode_code_generator_1.default.plugins.style.css(),
            ],
            pages: [
                lowcode_code_generator_1.default.plugins.react.reactCommonDeps(),
                lowcode_code_generator_1.default.plugins.common.esmodule({ fileType: 'jsx' }),
                lowcode_code_generator_1.default.plugins.react.containerClass(),
                lowcode_code_generator_1.default.plugins.react.containerInjectContext(),
                lowcode_code_generator_1.default.plugins.react.containerInjectUtils(),
                lowcode_code_generator_1.default.plugins.react.containerInjectDataSourceEngine(),
                lowcode_code_generator_1.default.plugins.react.containerInjectI18n(),
                lowcode_code_generator_1.default.plugins.react.containerInitState(),
                lowcode_code_generator_1.default.plugins.react.containerLifeCycle(),
                lowcode_code_generator_1.default.plugins.react.containerMethod(),
                lowcode_code_generator_1.default.plugins.react.jsx({
                    nodeTypeMapping: {
                        Div: 'div',
                        Component: 'div',
                        Page: 'div',
                        Block: 'div',
                    },
                }),
                lowcode_code_generator_1.default.plugins.style.css(),
            ],
            router: [
                lowcode_code_generator_1.default.plugins.common.esmodule(),
                lowcode_code_generator_1.default.solutionParts.icejs.plugins.router()
            ],
            entry: [lowcode_code_generator_1.default.solutionParts.icejs.plugins.entry()],
            constants: [lowcode_code_generator_1.default.plugins.project.constants()],
            utils: [
                lowcode_code_generator_1.default.plugins.common.esmodule(),
                lowcode_code_generator_1.default.plugins.project.utils('react'),
            ],
            i18n: [lowcode_code_generator_1.default.plugins.project.i18n()],
            globalStyle: [lowcode_code_generator_1.default.solutionParts.icejs.plugins.globalStyle()],
            htmlEntry: [lowcode_code_generator_1.default.solutionParts.icejs.plugins.entryHtml()],
            packageJSON: [lowcode_code_generator_1.default.solutionParts.icejs.plugins.packageJSON()],
        },
        postProcessors: [lowcode_code_generator_1.default.postprocessor.prettier()],
        projectPostProcessors: [MenuConfig_1.default]
    });
}
exports.default = createLcpCodegenProjectBuilder;
//# sourceMappingURL=index.js.map